/* $Id: torgdev.h,v 1.8 2005/04/08 09:10:37 yuk Exp $ 
 *
 *  torgdev library, saledevices facility.
 *
 *  torgdev.h - main header file
 *
 *  Copyright (C) 1999, 2005  Yura Kalinichenko
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
*/
#ifdef	HAVE_CONFIG_H
#include <iceb.h>
#endif

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifdef AMC_ENABLED
#include <chon100.h>
#endif

#include        <nl_types.h>

extern char gerrmsg[132];

typedef unsigned char uchar;
/*     .
       catgets   .. > 0 - 
   : 0 -> 99                                      */
#define deverr(n, s) catgets(fils, 507, n?n:99, s)
/*    */
#define devmsg(n, s) catgets(fils, 508, n, s)

#define BUFSIZE 512
#define MAX_CASS 16

#define T_NONE 0
#define T_ERA 1
#define T_DATECS 2
#define T_MARIA 3

#define ECA_LOCK 1
#define ECA_CRC  2
#define ECA_TIM  3	
#define ECA_IO   4	
#define ECA_PROT  5	
#define ECA_TOO_MANY 6
#define ECA_PAR 7
#define ECA_OPEN 8
#define ECA_MEM 9

#define MAX_TOVAR_DATECS 800
#define MAX_TOVAR_ERA	 2500
#define MAX_TOVAR MAX_TOVAR_ERA

//        
#define ERRS_COMMON 0 
#define ERRS_MARIA 100
#define ERRS_AMC   400

/*      Ҧ-301:
	0 - Ҧ-301  U6020000901
	1 - Ҧ-301 U6020000901
	2 - Ҧ-301 U7020010707
*/
#ifndef MARIA_PROTOCOL_VERSION
#define	MARIA_PROTOCOL_VERSION 2
#endif

struct cassa_pars_struct {
  int type;
  char *port;
  int num;
  char *passwd;
};

struct cassa_tovar_struct {
     uint 	cod;		/*   1-2500  ERA, 
     				   1-800  Datecs 	        */
     uint 	gr_NDS;		/*   0-4 ERA, 0-8 - Datecs */
     uint 	gr_TOV; 	/*   1-32 ERA, 1-99 Datecs*/
     uint 	depart;		/*  0-31 ERA, 0-9 Datecs	*/
     uint 	drob;	 	/* 0 -  -  , 
     				 ..  (ERA)	*/
     uint 	test_ost;	/* 0 -     , 
     				 -  	*/
     uint	free_c;		/*      ? */
     double 	cena;		/*   		*/
     double 	ost;		/*   () 	*/
     double 	oborot;		/*  	   	*/
     uchar 	name[16];	/*  12 .  ERA
     				   14  Datecs 	        */
     char 	barcode[14];	/* -, 13 , ERA	*/
};

typedef struct cassa_tovar_struct cassa_tovar;
typedef struct cassa_pars_struct cassa_pars;


#ifdef	__cplusplus
extern "C" {
#endif
/*========================= -802===================================*/
extern int era_open(char *port_name);
#define era_close() era_open(NULL)

/* era_prog_tovar() -       .
 *
 * :         ,
 *                 
 *             (     Z)
 *
 *  :
 *   cassa_pars	*cassa	-    
 *   cassa_tovar **tlist -   .  
 *                    ,
 *                MAX_TOVAR_ERA,  NULL.
 *
 *   int (*percent)() -     
 *                        NULL.
 * 			   
 *                      int =    .
 *   int (*prt)()     -     
 *                        NULL.
 * 			    
 *                      cassa_tovar* =   
 *		           .
 *                      
 * Return:
 *   0 - OK
 *    -    CA_error()
 */
int era_prog_tovar(cassa_pars *cassa, cassa_tovar **tlist, int (*percent)(int),
	int (*prt)(cassa_tovar*));

/* era_otch_tovar() -     
 *
 *  :
 *   cassa_pars	*cassa	-    
 *   uint first -   
 *   uint last  -   .
 *   int (*percent)() -     
 *                        NULL.
 * 			   
 *                      int =    .
 *
 *  :
 *   cassa_tovar **tlist -   .  
 *                    ,
 *                MAX_TOVAR_ERA.   
 *		  free().    
 *		   ,   - NULL.
 *                     
 *		        free().
 *		  :
 *                cod -  
 *                name - 
 *                ost -   
 *                cena -  
 *                      
 * Return:
 *   0 - OK
 *    -    CA_error()
 */
extern int era_otch_tovar(cassa_pars *cassa, uint first, uint last, 
	cassa_tovar **tlist, int (*percent)(int));

/* free_tovar_list() -  ,  
 *                     
 */
extern void free_tovar_list(cassa_tovar **pt);
/*===========================  -301=================*/

/* 1.   */

#define TOVAR_NAMLEN 60
#define SKIDKA_NAMLEN 13

/* C     */
struct check_rec_struct {
       struct check_rec_struct *next; /*   .    */
       struct check_rec_struct *pred; /*   .    */
       uchar name[TOVAR_NAMLEN+1];  /* .                         */
       int    art;                /*  0-9999 */
       double sum;                /*                      */
       double sed;                /*  .        */
       double num;                /* -                              */
       int    nalog;              /*  , 1-8; 0 -     */
       uchar  skidka[SKIDKA_NAMLEN+1];
       double skidka_sum;
       };

typedef struct check_rec_struct check_record;

/*-----------------------------------------------------------------*/
/*  ,  add_check(),   :
 * Return:
 *   <0 -  
 *    0 - OK
 *   >0 -  coo  ,    
 *          maria_error(_)
 */

/*        */
extern uchar * maria_error(int errcod,nl_catd);

 
/*  2.     	*/

/* add_check -        
 *                .
 *  :
 *   check -    , NULL  
 *   name  - 60 . 
 *   art   -  0-9999
 *   sum   -  
 *   sed   -  .
 *   num   - -
 *   nalog -   1-8, 0 -  
 *   skidka -  . NULL   
 *   skidka_sum -  
 *
 * Return:
 *   NULL -  (      ), 
 *      struct check_record
 *
 */

extern check_record *
add_check(check_record *check, uchar *name, int art, 
          double sum, double sed, double num, int nalog,
	  uchar * skidka, double skidka_sum);

/*
 * maria_prcheck -      -301
 *
 *  :
 *   model -  (M_MARIA  M_MARIAT4)
 *   port_name -    ,  .  
 *   saler    - ,  4- .
 *   password -  10
 *   otd      -   .,  2 
 *   check    -     ,
 *   returned -    ? 0 - ,  - 
 *   sum      -    
 *      :
 *     sum_tara - 
 *     sum_pcheck -  
 *     sum_cred - 
 *     sum_nal  - 
 *   slug_text -  ,   ..
 *               NULL  "" -    
 *
 */
extern int
maria_prcheck(int model, uchar *port_name, uchar * saler, uchar * password,
uchar * otd, check_record **check, int returned, 
double sum, double sum_tara, double sum_pcheck,
double sum_cred, double sum_nal, uchar *slug_text);

/*
 * maria_indicator -     ( 16 )
 *
 *  :
 *   model -  (M_MARIA  M_MARIAT4)
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *   nstr  -   - 1  2
 *   message -  16 ;  NULL    -  
 *   pause -  .     
 *
 */
extern int 
maria_indicator(int model, uchar * port_name, uchar * saler, uchar * password, 
                int nstr, uchar * message, int pause);

/*
 * maria_linefeed -   
 *
 *  :
 *   model -  (M_MARIA  M_MARIAT4)
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *   nstr  - -  , 1-255
 *
 */
extern int 
maria_linefeed(int model, uchar * port_name, uchar * saler, uchar * password, 
               int nstr);
/*
 * maria_null -   
 */
extern int
maria_null(int model, uchar *port_name, uchar * saler, uchar * password);

/*
 * maria_copy -   
 */
extern int 
maria_copy(int model,uchar *port_name,uchar * saler,uchar * password);

/*
 * maria_slug -  / 
 */
extern int
maria_slug(int model, uchar *port_name,uchar * saler,uchar * password, double summa);
/*------------------------------------------------------------------------*/

/* 3.    */
/*
 * maria_day_report -      
 *    -301
 *
 *  :
 *   model -  (M_MARIA  M_MARIAT4)
 *   port_name -    ,  .  
 *   saler    -   4
 *   password - 
 *   clr_reg  -    ? 0 - , 1 - 
 *
 */
extern int 
maria_day_report(int model,uchar * port_name, uchar * saler, uchar * password,
                int clr_reg);

/*
 * maria_date_report -     
 *   
 *    -301
 *
 *  :
 *   model -  (M_MARIA  M_MARIAT4)
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *      :
 *     day_from   - 
 *     month_from - 
 *     year_from  - 
 *     :
 *     day_to   - 
 *     month_to - 
 *     year_to  - 
 *
 */

extern int 
maria_date_report(int model, uchar * port_name, uchar * saler, uchar * password,
                  int day_from, int month_from, int year_from,
                  int day_to, int month_to, int year_to);

/*------------------------------------------------------------------------*/

/* 4.   */

/* maria_setcheck -     
 *   model -  (M_MARIA  M_MARIAT4)
 *   port_name -    ,  .  
 *   saler    - ,  4- .
 *   password -  10
 *   head     -   18
 *   botm     -   18
 */
extern int
maria_setcheck(int model, uchar *port_name, uchar *saler, uchar *password,
	uchar *head, uchar *botm);

/*
 * maria_nalog -  ,   1-8
 *
 *  :
 *   model -  (M_MARIA  M_MARIAT4)
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *   name     -   5
 *   number;  -   1-8
 *   included -  : 0 - ;
 *		1 -   
 *		2 -    ()
 *   percent  -  
 *
 */
extern int 
maria_nalog(int model, uchar * port_name, uchar * saler, uchar * password,
            uchar * name, int number, int included, double percent);


/*
 * maria_reginfo -   
 *                  
 *  :
 *   model -  (M_MARIA  M_MARIAT4)
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *   fisc_no -   10
 *   cod_edrpou -       
 *                       10
 *   cod_platnika -    12, 000000000000 -   
 *   firma -   18
 *   address -	 18
 *
 */
extern int
maria_reginfo(int model, uchar *port_name, uchar * saler, uchar * password,
	char *fisc_no, 
#if ( MARIA_PROTOCOL_VERSION > 1 )
	char *cod_edrpou,
#endif
	char *cod_platnika, uchar *firma, uchar *address);

/*
 * maria_valuta -  
 *  :
 *   model -  (M_MARIA  M_MARIAT4)
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *   mantissa - -    
 *   valuta -   3
 */
extern int
maria_valuta(int model, uchar *port_name,uchar * saler,uchar * password,
	uint mantissa, char *valuta);

/*
 * maria_time -     (  +- 1  !!!)
 *
 *  :
 *   model -  (M_MARIA  M_MARIAT4)
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *   hour - 
 *   min  - 
 *   sec  - 
 *
 */
extern int 
maria_time(int model, uchar * port_name, uchar * saler, uchar * password, 
           int hour, int min, int sec);

/*
 * maria_gettime -  / (    !!!)
 *
 *  :
 *   port_name -    ,  .  
 *   saler -   4
 *   password - 
 *  :
 *   year - 
 *   mon - 
 *   day - 
 *
 *   hour - 
 *   min  - 
 *   sec  - 
 *
 */
extern int 
maria_gettime(int model, uchar * port_name, uchar * saler, uchar * password, 
           int *year, int *mon, int *day, int *hour, int *min, int *sec);

#ifdef AMC_ENABLED
/*    Chon100    -100 ()   */
#define AMC_CONFIG "/check.amc"
extern int init_amc(char *port_name, char *supplier_code);
extern void deinit_amc(char *port_name);
extern int amc_prcheck(char *port_name, char *supplier_code, uchar * otd, check_record **check, int returned);
extern int amc_setcheck(uchar *head, int double_head, uchar *botm, int double_botm);
#endif

/*------------------------------------------------------------------------*/

#define TD_ERROR_NONE 0
#define TD_ERROR_HOST_NOT_FOUND -1
#define TD_ERROR_SERVICE_NOT_FOUND -2
#define TD_ERROR_CREATE_SOCKET -3
#define TD_ERROR_CONNECT_HOST -4
#define TD_ERROR_SEND_HOST -5
#define TD_ERROR_SEND_DATA -6
#define TD_ERROR_READ_DATA -7
#define TD_ERROR_LARGE_BLOCK -8
#define TD_ERROR_INVALID_HANDLE -9
#define TD_ERROR_NO_MORE_HANDLE -10

/*     (bitmask) */
#define M_MARIA 	1
#define M_AMC100F	2
#define M_MARIAT4 	4
#define M_UNKNOWN	0

/*     */
#define C_MARIA		"MARIA-301"
#define C_MARIAT4	"MARIA-301T4"
#define C_AMC		"AMC-100F"
#define C_UNKNOWN	"UNKNOWN"

/*  __ <-> _ 	*/
extern int name2type(char *devname);
extern char *type2name(int devtype);

/*======================= -===============================*/

/*
 * scan -    -
 *  :
 *   tty_name -    ,    
 *   timeout  -  .    (< 0,  )
 *   kbhit   -    ,                
 *                .    
 *               ; ,    
 *                            
 *               : 
 *
 *             0 -   ;
 *             1 -  
 *
 *              NULL,      
 *              
 *
 *
 *  :
 *   ret_cod  -  c   -
 *
 * Return:
 *     >0 -  ,  
 *     0  -      
 *    -1  -    
 *    -2  -  /
 *    -3  -   
 */

extern int scan (uchar *tty_name, double timeout, uchar *ret_cod, 
                int (*kbhit)());

/*===================== AP-1=========================================*/

/*
 * ves -     
 *
 *  :
 *   tty_name -   ,    
 *               "local" - ,   
 *   attempts - .     
 *   timeout  - .   
 *   kbhit   -    ,                
 *                .    
 *               ; ,    
 *                            
 *               : 
 *
 *             0 -   ;
 *             1 -  
 *
 *              NULL,      
 *              
 *
 * :
 *   ret_ves  - c   
 *
 * Return:
 *     1  -  
 *     0  -      
 *    -1  -    
 *    -2  -  /
 *    -3  -   
 *
 */
extern int ves  (uchar *tty_name, int attempts, double timeout, 
                double *ret_ves, int (*kbhit)());

/*===================== .=================================*/

/*
 * card_read -    
 *
 *  :
 *   tty_name -   ,    
 *               "local" - ,   
 *   timeout  - .    (< 0,  )
 *
 * :
 *   cod  - c    (10  + '\0')
 *
 * Return:
 *    >0  -    (10)   
 *     0  -      
 *    -1  -   
 *    -2  -  /,  - errno
 *    -3  -   ,  - errno
 *
 */
extern int card_read(char *tty_name, double timeout, uchar *cod);

/*
 * card_close -  
 */
extern void card_close(char *tty_name);


/*====================   DATECS MP-500 ===================*/

/*============    IN-LINE ===========*/
/* SG_error()
 *  
 *       Datecs
 *
 *   :
 *    int errcod -  
 *  
 *  Return:
 *      
 *
 */
extern char *CA_error(int errcod);

/* SGI_nop()
 *   
 *
 *   :
 *   cassa_pars	*cassa	-    
 *   
 *  Return:
 *   0 - OK
 *   else -    CA_error
 */
extern int SGI_nop(cassa_pars *cassa);

/* SGI_print()
 *      18 
 *
 *   :
 *   cassa_pars	*cassa	-    
 *   char *str  	-   
 *   
 *  Return:
 *   0 - OK
 *   else -    CA_error
 */
extern int SGI_print(cassa_pars *cassa, char *str) ;

/* SGI_read_trec()
 *      
 *
 *   :
 *   cassa_pars	*cassa	-    
 *   uint tabno  	-   ( 0)
 *   uint recno  	-     ( 1)
 *   
 *   :
 *   char *rec 	-  
 *   
 *  Return:
 *   0 - OK
 *   else -    CA_error
 */
extern int 
SGI_read_trec(cassa_pars *cassa, uint tabno, uint recno, char *rec) ;

/*
 *       
 *
 *   :
 *   cassa_pars	*cassa	-    
 *   uint tabno  	-  
 *   int first	-     (c 1)
 *   int last	-     (c 1), 
 *   		   -    
 *   int usereof() -  /     NULL.
 *                      
 *   		   ,    
 *		   .
 *   
 *   :
 *   uchar **tab -  NULL   
 *		    .   
 *		      free() !!!
 *   
 *  Return:
 *   0 - OK
 *   else -    CA_error
 */
extern int 
SGI_read_table(cassa_pars *cassa, uint tabno, int first, int last, 
		uchar **tab, int usreof(char*)) ;

/* SGI_write_table()
 *     
 *
 *   :
 *   cassa_pars	*cassa	-    
 *   uint tabno  	-  
 *   uint recno  	-    
 *   uint rec	-   
 *   
 *  Return:
 *   0 - OK
 *   else -    CA_error
 */
extern int 
SGI_write_table(cassa_pars *cassa, uint tabno, uint recno, uchar *rec);

/* SGI_write_list()
 *      ,   
 *
 *   :
 *   cassa_pars	*cassa	-    
 *   uint tabno  	-  
 *   uchar **rec	-  ,  NULL
 *   
 *  Return:
 *   0 - OK
 *   else -    CA_error
 */
extern int SGI_write_list(cassa_pars *cassa, uint tabno, uchar **rec);

/*====      IN-LINE ===========*/

/* SG_prog_tovar
 *    
 *
 *   :
 *   cassa_pars	*cassa	-    
 *   cassa_tovar **tlist -   .  
 *                    ,
 *                MAX_TOVAR_DATECS,  NULL.
 *
 *   int (*percent()) -     
 *                        NULL.
 * 			   
 *                      int =    .
 *   int (*prt)()     -     
 *                        NULL.
 * 			   
 *                      int =    tlist   .
 *
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *
 */
extern int
SG_prog_tovar(cassa_pars *cassa, cassa_tovar **tlist, int (*percent)(int),
	int (*prt)(cassa_tovar*));

/* SG_otch_tovar()
 *       . 
 *   :
 *   cassa_pars	*cassa	-    
 *   uint first -   
 *   uint last  -   .
 *   int (*percent()) -     
 *                        NULL.
 * 			   
 *                      int =    .
 *   cassa_tovar **tlist -   .  
 *                    ,
 *                MAX_TOVAR_DATECS.   
 *		  free().    
 *		   ,   - NULL.
 *                     
 *		        free().
 *		  :
 *                cod -  
 *                name - 
 *                ost -  
 *                cena -  
 *                oborot -  
 *
 *  Return:
 *     0  - OK
 *     else - 
 *
 */
extern int
SG_otch_tovar(cassa_pars *cassa, uint first, uint last, 
	cassa_tovar **tlist, int (*percent)(int));

/* SG_prog_srv()
 *     .
 *      .
 *   -    ,
 *      :
 *  
 *    -1 -  
 *    NULL -  
 *  
 *   :
 *   cassa_pars	*cassa	-    
 *     int new_knum    -    1-99
 *     int k_type      -  : 
 *     		          0 -      
 *                              ;
 *     		          1 -  . ;
 *     		          2 - 
 *     int openbox     -   :
 *     		          0 -    = 0
 *     		          1 -    
 *     int need_sum    -     , 
 *			   :
 *     		     	  0 -  		
 *     		     	  1 -  (  
 *     		               )
 *     int no_change   -   ? 1 - , 0 - 
 *     int ind_off     -      ..
 *			  0 -  
 *			  1 -   30 .   
 *     int vd_exit     -       
 *			   :
 *     		          0 - 
 *     		          1 - ,   
 *     int mode	       -     :
 *			 0 - 
 *			 1 -  IN-LINE
 *			 2 - ON-LINE:    
 *			       ,  
 *			       
 *			 3 - ON-LINE:    
 *			      
 *			 4 - ON-LINE: KA   
 *			       
 *			 5 -   
 *			 6 -  
 *			 7 - ON-LINE:    
 *			         -
 *			     
 *			 8 - ""       
 *     int speed	-   :
 *			    1 - 1200
 *			    2 - 2400
 *			    3 - 4800 ()
 *			    4 - 9600
 *       
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *       
 */
extern int SG_prog_srv(cassa_pars *cassa, 
	int new_knum, int k_type, int openbox, int need_sum, 
	int no_change, int ind_off, int vd_exit, int mode, int speed);

/* SG_read_srv
 *     .
 *  
 *   :
 *   cassa_pars	*cassa	-    
 *
 *   :
 *     int *k_type     -  : 
 *     		          0 -      
 *                              ;
 *     		          1 -  . ;
 *     		          2 - 
 *     int *openbox    -   :
 *     		          0 -    = 0
 *     		          1 -    
 *     int *need_sum   -     , 
 *			   :
 *     		     	  0 -  		
 *     		     	  1 -  (  
 *     		               )
 *     int *no_change  -   ? 1 - , 0 - 
 *     int *ind_off    -      ..
 *			  0 -  
 *			  1 -   30 .   
 *     int *vd_exit    -       
 *			   :
 *     		          0 - 
 *     		          1 - ,   
 *     int *mode       -     :
 *			 0 - 
 *			 1 -  IN-LINE
 *			 2 - ON-LINE:    
 *			       ,  
 *			       
 *			 3 - ON-LINE:    
 *			      
 *			 4 - ON-LINE: KA   
 *			       
 *			 5 -   
 *			 6 -  
 *			 7 - ON-LINE:    
 *			         -
 *			     
 *			 8 - ""   
 *     int *speed	-   :
 *			    1 - 1200
 *			    2 - 2400
 *			    3 - 4800 ()
 *			    4 - 9600
 *       
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *       
 */
extern int SG_read_srv(cassa_pars *cassa, 
	int *k_type, int *openbox, int *need_sum, 
	int *no_change, int *ind_off, int *vd_exit,
	int *mode, int *speed);

/* SG_prog_oper
 *     .
 *     ( 30 .)  
 *    .
 *      .
 *   -    ,
 *      :
 *  
 *    -1 -  
 *    NULL -  
 *  
 *   :
 *   cassa_pars	*cassa	-    
 *
 *     int onum		-   ( 1  30)
 *     char *oname	-  ,  10 
 *     char *opass 	- ,  8 
 *       
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *       
 */
extern int 
SG_prog_oper(cassa_pars *cassa, int onum, char *oname, char *opass);

/* SG_read_oper
 *      (  ).
 *  
 *   :
 *     cassa_pars *cassa -    
 *     int onum		-   ( 1  30)
 *
 *   :
 *     char *oname	-  ,  10 
 *     char *opass 	- ,  8 
 *       
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *       
 */
extern int 
SG_read_oper(cassa_pars *cassa, int onum, char *oname, char *opass);

/* SG_prog_check
 *     
 *      .
 *   -    ,
 *      :
 *  
 *    -1 -  
 *    NULL -  
 *  
 *   :
 *     cassa_pars *cassa -    
 *
 *     int no_klishe	-     :
 * 			    0 - 
 *			    1 - 
 *     int laststr      - -     
 *			    0-2
 *     int num_pok	-  -    ?
 * 			    0 - 
 *     int nalog	-     ?
 *			    0 - 
 *     int oname	-      ?
 *			    0 - 
 *     int strsum 	-     ? 
 *			    0 - 
 *			    1 -      
 *			        c
 *     int copies	-  -  (  ) 
 *			    0-3
 *     int srv_copies   -  -   
 *			    0-3
 *     char *klishe1	- 1-  ,  24 
 *     char *klishe2	- 2-  ,  24 .
 *     char *klishe3	- 3-  ,  24 .
 *     char *rekl1	- 1-  ,  24 .
 *     char *rekl2	- 2-  ,  24 .
 *     char *valuta	-  ,  3- .
 *
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *       
 */
extern int SG_prog_check(cassa_pars *cassa, 
	int no_klishe, int laststr, int num_pok, int nalog, 
	int oname, int strsum, int copies, int srv_copies, 
	char *klishe1, char *klishe2, char *klishe3,
	char *rekl1, char *rekl2, char *valuta);
	
/* SG_read_check
 *       
 *  
 *   :
 *     cassa_pars *cassa -    
 *
 *   :
 *     int *no_klishe	-     :
 * 			    0 - 
 *			    1 - 
 *     int *laststr      - -     
 *			    0-2
 *     int *num_pok	-  -    ?
 * 			    0 - 
 *     int *nalog	-     ?
 *			    0 - 
 *     int *oname	-      ?
 *			    0 - 
 *     int *strsum 	-     ? 
 *			    0 - 
 *			    1 -      
 *			        c
 *     int *copies	-  -  (  ) 
 *			    0-3
 *     int *srv_copies   -  -   
 *			    0-3
 *     char *klishe1	- 1-  ,  24 
 *     char *klishe2	- 2-  ,  24 .
 *     char *klishe3	- 3-  ,  24 .
 *     char *rekl1	- 1-  ,  24 .
 *     char *rekl2	- 2-  ,  24 .
 *     char *valuta	-  ,  3- .
 *
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *       
 */
extern int SG_read_check(cassa_pars *cassa, 
	int *no_klishe, int *laststr, int *num_pok, int *nalog, 
	int *oname, int *strsum, int *copies, int *srv_copies, 
	char *klishe1, char *klishe2, char *klishe3,
	char *rekl1, char *rekl2, char *valuta);

/* SG_prog_time
 *     
 *      .
 *   -    ,
 *      :
 *  
 *    -1 -  
 *    NULL -  
 *  
 *   :
 *     cassa_pars *cassa -    
 *
 *     int hour         - , 0-24
 *     int minute       -  0-59
 *
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *       
 */
extern int SG_prog_time(cassa_pars *cassa, int hour, int minute);

/* SG_read_time
 *     
 *  
 *   :
 *     cassa_pars *cassa -    
 *
 *   :
 *     int *hour        - , 0-24
 *     int *minute      -  0-59
 *
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *       
 */
extern int SG_read_time(cassa_pars *cassa, int *hour, int *minute);

/*============      ===========*/
/* SG_prcheck
 *       .
 *
 *   :
 *     cassa_pars *cassa -    
 *     cassa_tovar *t    -    
 *
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *       
 */
extern int SG_prcheck(cassa_pars *cassa, cassa_tovar *t);

/*------------       Samsung-----*/
/* Cassa_connect()
 *       
 *  
 *   :
 *     cassa_pars *cassa -    
 *
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *       
 */
extern int Cassa_connect(cassa_pars *cassa);

/* Cassa_prog_tovar(cassa, tlist, percent)
 *    
 *
 *   :
 *   cassa_pars	*cassa	-    
 *   cassa_tovar **tlist -   .  
 *                    ,
 *                MAX_TOVAR_DATECS,  NULL.
 *
 *   int (*percent()) -     
 *                        NULL.
 * 			   
 *                      int =    .
 *
 *  Return:
 *   0 - OK
 *   else -    CA_error
 *
 */
#define Cassa_prog_tovar(casdef, tovlist, prog, prt) \
   ((casdef->type == T_ERA) ? \
   era_prog_tovar(casdef, tovlist, prog, prt) : \
   SG_prog_tovar(casdef, tovlist, prog, prt) )

/* Cassa_otch_tovar(cassa, first, last, tlist, percent)
 *       . 
 *   :
 *   cassa_pars	*cassa	-    
 *   uint first -   
 *   uint last  -   .
 *   int (*percent()) -     
 *                        NULL.
 * 			   
 *                      int =    .
 *   cassa_tovar **tlist -   .  
 *                    ,
 *                  MAX_TOVAR.   
 *		  free().    
 *		   ,   - NULL.
 *                     
 *		        free().
 *		  :
 *                cod -  
 *                name - 
 *                ost -  
 *                cena -  
 *                      
 *
 *  Return:
 *     0  - OK
 *     else - 
 *
 */
#define Cassa_otch_tovar(casdef, min, max, tovlist, prog) \
   ((casdef->type == T_ERA) ? \
   era_otch_tovar(casdef, min, max, tovlist, prog) : \
   SG_otch_tovar(casdef, min, max, tovlist, prog) )

void free_check(check_record **check);
void show_error(uchar*);
#ifdef	__cplusplus
}
#endif
